<?php

/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package bakery_confectionery
 */

function bakery_confectionery_customize_css() {
    ?>
    <style type="text/css">
        :root {
            --primary-color: <?php echo esc_html( get_theme_mod( 'bakery_confectionery_primary_color', '#ff5d80' ) ); ?>;
        }
    </style>
    <?php
}
add_action( 'wp_head', 'bakery_confectionery_customize_css' );

function bakery_confectionery_enqueue_selected_fonts() {
    $bakery_confectionery_fonts_url = bakery_confectionery_get_fonts_url();
    if (!empty($bakery_confectionery_fonts_url)) {
        wp_enqueue_style('bakery-confectionery-google-fonts', $bakery_confectionery_fonts_url, array(), null);
    }
}
add_action('wp_enqueue_scripts', 'bakery_confectionery_enqueue_selected_fonts');

function bakery_confectionery_layout_customizer_css() {
    $bakery_confectionery_margin = get_theme_mod('bakery_confectionery_layout_width_margin', 50);
    ?>
    <style type="text/css">
        body.site-boxed--layout #page  {
            margin: 0 <?php echo esc_attr($bakery_confectionery_margin); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_layout_customizer_css');

function bakery_confectionery_blog_layout_customizer_css() {
    // Retrieve the blog layout option
    $bakery_confectionery_blog_layout_option = get_theme_mod('bakery_confectionery_blog_layout_option_setting', 'Left');

    // Initialize custom CSS variable
    $bakery_confectionery_custom_css = '';

    // Generate custom CSS based on the layout option
    if ($bakery_confectionery_blog_layout_option === 'Default') {
        $bakery_confectionery_custom_css .= '.mag-post-detail { text-align: center; }';
    } elseif ($bakery_confectionery_blog_layout_option === 'Left') {
        $bakery_confectionery_custom_css .= '.mag-post-detail { text-align: left; }';
    } elseif ($bakery_confectionery_blog_layout_option === 'Right') {
        $bakery_confectionery_custom_css .= '.mag-post-detail { text-align: right; }';
    }

    // Output the combined CSS
    ?>
    <style type="text/css">
        <?php echo wp_kses($bakery_confectionery_custom_css, array( 'style' => array(), 'text-align' => array() )); ?>
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_blog_layout_customizer_css');

// Featured Image Dimension
function bakery_confectionery_custom_featured_image_css() {
    $bakery_confectionery_dimension = get_theme_mod('bakery_confectionery_blog_post_featured_image_dimension', 'default');
    $bakery_confectionery_width = get_theme_mod('bakery_confectionery_blog_post_featured_image_custom_width', '');
    $bakery_confectionery_height = get_theme_mod('bakery_confectionery_blog_post_featured_image_custom_height', '');
    
    if ($bakery_confectionery_dimension === 'custom' && $bakery_confectionery_width && $bakery_confectionery_height) {
        $bakery_confectionery_custom_css = "body:not(.single-post) .mag-post-single .mag-post-img img { width: {$bakery_confectionery_width}px !important; height: {$bakery_confectionery_height}px !important; }";
        wp_add_inline_style('bakery-confectionery-style', $bakery_confectionery_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'bakery_confectionery_custom_featured_image_css');

// Featured Image Border Radius
function bakery_confectionery_featured_image_border_radius_css() {
    $bakery_confectionery_featured_image_border_radius = get_theme_mod('bakery_confectionery_featured_image_border_radius', 10);
    ?>
    <style type="text/css">  
        .mag-post-single img {
            border-radius: <?php echo esc_attr($bakery_confectionery_featured_image_border_radius); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_featured_image_border_radius_css');

function bakery_confectionery_sidebar_width_customizer_css() {
    $bakery_confectionery_sidebar_width = get_theme_mod('bakery_confectionery_sidebar_width', '30');
    ?>
    <style type="text/css">
        .right-sidebar .asterthemes-wrapper .asterthemes-page {
            grid-template-columns: auto <?php echo esc_attr($bakery_confectionery_sidebar_width); ?>%;
        }
        .left-sidebar .asterthemes-wrapper .asterthemes-page {
            grid-template-columns: <?php echo esc_attr($bakery_confectionery_sidebar_width); ?>% auto;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_sidebar_width_customizer_css');

if ( ! function_exists( 'bakery_confectionery_get_page_title' ) ) {
    function bakery_confectionery_get_page_title() {
        $bakery_confectionery_title = '';

        if (is_404()) {
            $bakery_confectionery_title = esc_html__('Page Not Found', 'bakery-confectionery');
        } elseif (is_search()) {
            $bakery_confectionery_title = esc_html__('Search Results for: ', 'bakery-confectionery') . esc_html(get_search_query());
        } elseif (is_home() && !is_front_page()) {
            $bakery_confectionery_title = esc_html__('Blogs', 'bakery-confectionery');
        } elseif (function_exists('is_shop') && is_shop()) {
            $bakery_confectionery_title = esc_html__('Shop', 'bakery-confectionery');
        } elseif (is_page()) {
            $bakery_confectionery_title = get_the_title();
        } elseif (is_single()) {
            $bakery_confectionery_title = get_the_title();
        } elseif (is_archive()) {
            $bakery_confectionery_title = get_the_archive_title();
        } else {
            $bakery_confectionery_title = get_the_archive_title();
        }

        return apply_filters('bakery_confectionery_page_title', $bakery_confectionery_title);
    }
}

if ( ! function_exists( 'bakery_confectionery_has_page_header' ) ) {
    function bakery_confectionery_has_page_header() {
        // Default to true (display header)
        $bakery_confectionery_return = true;

        // Custom conditions for disabling the header
        if ('hide-all-devices' === get_theme_mod('bakery_confectionery_page_header_visibility', 'all-devices')) {
            $bakery_confectionery_return = false;
        }

        // Apply filters and return
        return apply_filters('bakery_confectionery_display_page_header', $bakery_confectionery_return);
    }
}

if ( ! function_exists( 'bakery_confectionery_page_header_style' ) ) {
    function bakery_confectionery_page_header_style() {
        $bakery_confectionery_style = get_theme_mod('bakery_confectionery_page_header_style', 'default');
        return apply_filters('bakery_confectionery_page_header_style', $bakery_confectionery_style);
    }
}

function bakery_confectionery_page_title_customizer_css() {
    $bakery_confectionery_layout_option = get_theme_mod('bakery_confectionery_page_header_layout', 'left');
    ?>
    <style type="text/css">
        .asterthemes-wrapper.page-header-inner {
            <?php if ($bakery_confectionery_layout_option === 'flex') : ?>
                display: flex;
                justify-content: space-between;
                align-items: center;
            <?php else : ?>
                text-align: <?php echo esc_attr($bakery_confectionery_layout_option); ?>;
            <?php endif; ?>
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_page_title_customizer_css');

function bakery_confectionery_pagetitle_height_css() {
    $bakery_confectionery_height = get_theme_mod('bakery_confectionery_pagetitle_height', 50);
    ?>
    <style type="text/css">
        header.page-header {
            padding: <?php echo esc_attr($bakery_confectionery_height); ?>px 0;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_pagetitle_height_css');

function bakery_confectionery_site_logo_width() {
    $bakery_confectionery_site_logo_width = get_theme_mod('bakery_confectionery_site_logo_width', 200);
    ?>
    <style type="text/css">
        .site-logo img {
            max-width: <?php echo esc_attr($bakery_confectionery_site_logo_width); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_site_logo_width');

function bakery_confectionery_menu_font_size_css() {
    $bakery_confectionery_menu_font_size = get_theme_mod('bakery_confectionery_menu_font_size', 16);
    ?>
    <style type="text/css">
        .main-navigation a {
            font-size: <?php echo esc_attr($bakery_confectionery_menu_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_menu_font_size_css');

//Menu Font Weight
function bakery_confectionery_menu_font_weight_css() {
	$bakery_confectionery_font_weight = get_theme_mod( 'bakery_confectionery_menu_font_weight', 400);

	$bakery_confectionery_custom_css = "
		.main-navigation a {
		    font-weight: {$bakery_confectionery_font_weight};
		}
	";

	wp_add_inline_style( 'bakery-confectionery-style', $bakery_confectionery_custom_css );
}
add_action( 'wp_enqueue_scripts', 'bakery_confectionery_menu_font_weight_css' );

function bakery_confectionery_sidebar_widget_font_size_css() {
    $bakery_confectionery_sidebar_widget_font_size = get_theme_mod('bakery_confectionery_sidebar_widget_font_size', 24);
    ?>
    <style type="text/css">
        h2.wp-block-heading,aside#secondary .widgettitle,aside#secondary .widget-title {
            font-size: <?php echo esc_attr($bakery_confectionery_sidebar_widget_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_sidebar_widget_font_size_css');

// Woocommerce Related Products Settings
function bakery_confectionery_related_product_css() {
    $bakery_confectionery_related_product_show_hide = get_theme_mod('bakery_confectionery_related_product_show_hide', true);

    if ( $bakery_confectionery_related_product_show_hide != true) {
        ?>
        <style type="text/css">
            .related.products {
                display: none;
            }
        </style>
        <?php
    }
}
add_action('wp_head', 'bakery_confectionery_related_product_css');

// Woocommerce Product Sale Position 
function bakery_confectionery_product_sale_position_customizer_css() {
    $bakery_confectionery_layout_option = get_theme_mod('bakery_confectionery_product_sale_position', 'left');
    ?>
    <style type="text/css">
        .woocommerce ul.products li.product .onsale{
            <?php if ($bakery_confectionery_layout_option === 'left') : ?>
                right: auto;
                left: 0px;
            <?php else : ?>
                left: auto;
                right: 0px;
            <?php endif; ?>
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_product_sale_position_customizer_css'); 

//Footer Social Icon Alignment
function bakery_confectionery_footer_icons_alignment_css() {
    $bakery_confectionery_footer_social_align = get_theme_mod( 'bakery_confectionery_footer_social_align', 'center' );   
    ?>
    <style type="text/css">
        .socialicons {
            text-align: <?php echo esc_attr( $bakery_confectionery_footer_social_align ); ?> 
        }

        /* Mobile Specific */
        @media screen and (max-width: 575px) {
            .socialicons {
                text-align: center;
            }
        }
    </style>
    <?php
}
add_action( 'wp_head', 'bakery_confectionery_footer_icons_alignment_css' );

//Copyright Alignment
function bakery_confectionery_footer_copyright_alignment_css() {
    $bakery_confectionery_footer_bottom_align = get_theme_mod( 'bakery_confectionery_footer_bottom_align', 'center' );   
    ?>
    <style type="text/css">
        .site-footer-bottom .site-footer-bottom-wrapper {
            display: flex;
            justify-content: <?php echo esc_attr( $bakery_confectionery_footer_bottom_align ); ?> 
        }

        /* Mobile Specific */
        @media screen and (max-width: 575px) {
            .site-footer-bottom .site-footer-bottom-wrapper {
                display: flex;
                justify-content: center;
                text-align:center;
            }
        }
    </style>
    <?php
}
add_action( 'wp_head', 'bakery_confectionery_footer_copyright_alignment_css' );

//Copyright Font Size
function bakery_confectionery_copyright_font_size_css() {
    $bakery_confectionery_copyright_font_size = get_theme_mod('bakery_confectionery_copyright_font_size', 16);
    ?>
    <style type="text/css">
        .site-footer-bottom .site-info span {
            font-size: <?php echo esc_attr($bakery_confectionery_copyright_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_copyright_font_size_css');

// Preloader Background Color Setting
function bakery_confectionery_preloader_background_colors_css() {
    $bakery_confectionery_preloader_background_color_setting = get_theme_mod('bakery_confectionery_preloader_background_color_setting', '');
        // Only output CSS if a color is set
        if (empty($bakery_confectionery_preloader_background_color_setting)) {
            return;
        }
    ?>
    <style type="text/css">
        #loader {
            background-color: <?php echo esc_attr($bakery_confectionery_preloader_background_color_setting); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_preloader_background_colors_css');

// Preloader Background Image Setting
function bakery_confectionery_preloader_background_image_css() {
    $bakery_confectionery_preloader_background_image_setting = get_theme_mod('bakery_confectionery_preloader_background_image_setting', '');
        // Only output CSS if the background image is set
        if (empty($bakery_confectionery_preloader_background_image_setting)) {
            return;
        }
    ?>
    <style type="text/css">
        #loader {
            background-image: url('<?php echo esc_url($bakery_confectionery_preloader_background_image_setting); ?>');
            background-size: cover;
            background-repeat: no-repeat;
            background-position: center;
        }
    </style>
    <?php
}
add_action('wp_head', 'bakery_confectionery_preloader_background_image_css');

//Footer Heading Alignment
function bakery_confectionery_footer_heading_alignment_css() {
    $bakery_confectionery_footer_header_align = get_theme_mod( 'bakery_confectionery_footer_header_align', 'left' );   
    ?>
    <style type="text/css">
        .site-footer h4, footer#colophon h2.wp-block-heading, footer#colophon .widgettitle, footer#colophon .widget-title {
            text-align: <?php echo esc_attr( $bakery_confectionery_footer_header_align ); ?> 
        }
    </style>
    <?php
}
add_action( 'wp_head', 'bakery_confectionery_footer_heading_alignment_css' );

//First Capital Letter
function bakery_confectionery_show_first_caps() {
	$bakery_confectionery_first_caps = get_theme_mod('bakery_confectionery_show_first_caps', false);
	$bakery_confectionery_css = '';
	if ( $bakery_confectionery_first_caps ) {
	$bakery_confectionery_css .= '
		.mag-post-single .mag-post-detail .mag-post-excerpt p:first-of-type::first-letter {
		    font-size: 55px;
			font-weight: 600;
			margin-right: 6px;
			line-height: 1;
			display: inline-block;
			vertical-align: baseline;
		}';
	} else {
		$bakery_confectionery_css .= '
		.mag-post-single .mag-post-detail .mag-post-excerpt p:first-of-type::first-letter {
			display: none;
		}';
	}
	wp_add_inline_style( 'bakery-confectionery-style', $bakery_confectionery_css );
}
add_action( 'wp_enqueue_scripts', 'bakery_confectionery_show_first_caps' );

// Banner Button Color
function bakery_confectionery_banner_button_color_css() {
    $btn_color = get_theme_mod('bakery_confectionery_banner_btn_color');
	$btn_bg_color = get_theme_mod('bakery_confectionery_banner_btn_bg_color');

	$custom_css = '';
    if ( !empty($btn_color) ) {
		$custom_css .= "
		.banner-slider-btn a.asterthemes-button{
			color: {$btn_color};
		}";
	}

	if ( !empty($btn_bg_color) ) {
		$custom_css .= "
		.banner-slider-btn a.asterthemes-button{
			background-color: {$btn_bg_color};
		}";
	}

	wp_add_inline_style('bakery-confectionery-style', $custom_css);
}
add_action('wp_enqueue_scripts','bakery_confectionery_banner_button_color_css');

// Topbar Padding Dynamic CSS
function bakery_confectionery_topbar_padding_css(){
	$padding = get_theme_mod('bakery_confectionery_topbar_padding');
	$custom_css = ".top-header-part{
		padding-top: {$padding}px !important;
		padding-bottom: {$padding}px !important;
	}";
	wp_add_inline_style('bakery-confectionery-style',$custom_css);

}
add_action('wp_enqueue_scripts','bakery_confectionery_topbar_padding_css');
